Subject: Re: [EN] NNCP 7.1.0 release announcement

From: Sergey Matveev <[email-masked]>
Date: Tue, 6 Jul 2021 12:57:52 +0300

*** John Goerzen [2021-07-05 16:38]:
>What's odd is that it corrupted about 5 out of 15 files that were generated
>at the time -- and they were all small ones.  The bigger ones were fine.

Currently I can not reproduce that issue locally. I use "nncp-exec -"
analogue for all my email -- have never seen that kind of issues.

I creates a subset of relatively small various files with fio. 1000
files of 100-2000 bytes sizes:

    % cat foo.fio
    [mein]
    readwrite=write
    bssplit=100/:500/:1000/:1500/:2000/
    nrfiles=1000
    filesize=100-2000

Then I passed them through gpg and nncp-file -:
    for i (mein.0.*) gpg -r offline -e < $i | nncp-file - self:$i.gpg
and tossed:
    nncp-xfer -mkdir -node self /tmp/self-shared
    nncp-xfer -node self /tmp/self-shared
    nncp-toss
And then decrypted and checked if all the data is "undamaged":
    cd ~/incoming
    for i (*.gpg) gpg -d < $i > $i:r
    l *~*.gpg | sort | xargs cat | sha1
    cd fiodir
    l mein.0.* | sort | xargs cat | sha1
And all hashes are matched, no gpg errors.
I looked at the NNCP's code again and currently see nothing like some
kind of unflushed bufio-buffers and that code has not been touched for a
long time. Unfortunately currently I have got no ideas how to reproduce
the problem.

-- 
Sergey Matveev (http://www.stargrave.org/)
OpenPGP: CF60 E89A 5923 1E76 E263  6422 AE1A 8109 E498 57EF